//	Title: AudioUtil.java
//	Description: I[fBIp[eBeB
//	Version: 1.0
//	Date: 2004-4-16
//	Copyright 2004 by Ayumi Nakabayashi. All rights reserved.

import fri.util.Util;
import fri.swing.graph.GraphUtil;

/**
 *	I[fBIp[eBeB
 *	@author Ayumi Nakabayashi
 *	@version 1.0 2004-4-16
 */
public class AudioUtil {
	/**
	 *	W(m, M, k, K)̕߂ double ɂ.
	 *	̖ m, M, k, K ̏ꍇAWƂĉ߂.
	 *	@param s 
	 */
	static double atofFactored(String s) {
		int l = s.length();
		double factor = 1.0;		// W
		switch (s.charAt(l-1)) {
		case 'm':
			factor = 1e-3;
			break;
		case 'k':
		case 'K':
			factor = 1e3;
			break;
		case 'M':
			factor = 1e6;
			break;
		default:
			return Util.atof(s);
		}
		return factor * Util.atof(s.substring(0, l-1));
	}

	static public final double LOG2 = GraphUtil.log10(2.0);
	static public final double LOG5 = GraphUtil.log10(5.0);
	static String[] u = { "p", "n", "u", "m", "", "k", "M", "G" };

	/**
	 *	double ̃fVx(d)Ԃ.
	 */
	static public final double dB(double x) { return 20.0 * GraphUtil.log10(x); }

	/**
	 *	Complex ̃fVx(d)Ԃ.
	 */
	static public final double dB(Complex x) { return dB(x.abs()); }

	/**
	 *	HwPʂ̕ɕϊ.
	 *	@param x l̔z
	 */
	static public String[] eunit(double[] x) {
		String[] s = new String[x.length];
		for (int i = 0; i < x.length; i++) {
			if (x[i] == 0.0)
				s[i] = "0";
			else {
				double lx = GraphUtil.log10(x[i]) / 3.0;
				int sign = lx > 0.0 ? 1 : -1;
				int d = (int) (Math.abs(lx) + 1e-3) * sign;
System.out.println("lx=" + lx + ", d=" + d);
				s[i] = x[i] / Math.pow(10.0, d * 3.0) + u[d + 4];
			}
		}
		return s;
	}
}
