//	%W% %D% %T%
//	pbP[W
//	Copyright 2003, Ayumi Nakabayashi

/**
 *	pbP[W
 *	@author Ayumi Nakabayashi
 *	@version 1.0 2003/7/10
 */
public class Complex implements Cloneable {
	/**  */
	double r;
	/**  */
	double i;

	/**
	 *	P.
	 */
	static public Complex I = new Complex(0.0, 1.0);

	/**
	 *	f쐬.
	 *	@param re 
	 *	@param im 
	 */
	public Complex(double re, double im) {
		this.r = re;
		this.i = im;
	}

	/**
	 *	f쐬.
	 *	@param re 
	 */
	public Complex(double re) {
		this.r = re;
		this.i = 0.0;
	}

	/**
	 *	f̕Ԃ.
	 */
	public Object clone(Object f) {
		Complex cf = (Complex) f;
		return new Complex(cf.r, cf.i);
	}

	/**
	 *	Ԃ.
	 */
	public double re() {
		return r;
	}

	/**
	 *	Ԃ.
	 */
	public double im() {
		return i;
	}

	/**
	 *	ΒlԂ.
	 */
	public double abs() {
		double x = Math.abs(r);
		double y = Math.abs(i);
		if (x == 0.0)
			return y;
		if (y == 0.0)
			return x;
		if (x > y) {
			double t = y / x;
			return x * Math.sqrt(1.0 + t * t);
		}
		double t = x / y;
		return y * Math.sqrt(1.0 + t * t);
	}

	/**
	 *	ΊpԂ.
	 */
	public double arg() {
		if (i == 0.0 && r == 0.0)
			throw new RuntimeException("cannot arg for abs() == 0.0");
		return Math.atan2(i, r);
	}

	/**
	 *	a += b
	 */
	static public void add(Complex a, Complex b) {
		a.r += b.r;
		a.i += b.i;
	}

	/**
	 *	a -= b
	 */
	static public void sub(Complex a, Complex b) {
		a.r -= b.r;
		a.i -= b.i;
	}

	/**
	 *	a *= b
	 */
	static public void mul(Complex a, Complex b) {
		double r = a.r * b.r - a.i * b.i;
		double i = a.r * b.i + a.i * b.r;
		a.r = r;
		a.i = i;
	}

	/**
	 *	a /= b
	 */
	static public void div(Complex a, Complex b) {
		if (Math.abs(b.r) >= Math.abs(b.i)) {
			double r = b.i / b.r;
			double den = b.r + r * b.i;
			double re = (a.r + r * a.i) / den;
			double im = (a.i - r * a.r) / den;
			a.r = re;
			a.i = im;
		} else {
			double r = b.r / b.i;
			double den = b.i + r * b.r;
			double re = (r * a.r + a.i) / den;
			double im = (r * a.i - a.r) / den;
			a.r = re;
			a.i = im;
		}
	}

	/**
	 *	a = 1 / a
	 */
	static public void recipro(Complex a) {
		if (Math.abs(a.r) >= Math.abs(a.i)) {
			double r = a.i / a.r;
			double den = a.r + r * a.i;
			double re = 1.0 / den;
			double im = -r / den;
			a.r = re;
			a.i = im;
		} else {
			double r = a.r / a.i;
			double den = a.i + r * a.r;
			double re = r / den;
			double im = -1.0 / den;
			a.r = re;
			a.i = im;
		}
	}

	/**
	 *	a = -a
	 */
	static public void neg(Complex a) {
		a.r = -a.r;
		a.i = -a.i;
	}
}
