//	Title: ElecMeasureFrame.java
//	Description: vt[
//	Version: 1.0
//	Date: 2004-4-16
//	Copyright 2004 by Ayumi Nakabayashi. All rights reserved.

import fri.swing.graph.GraphComponent;
import java.awt.BorderLayout;
import java.awt.Component;
import java.awt.Container;
import java.awt.Dimension;
import java.awt.Graphics;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.Insets;
import java.awt.print.PageFormat;
import java.awt.print.Printable;
import java.awt.print.PrinterException;
import java.awt.print.PrinterJob;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedInputStream;
import java.io.BufferedOutputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.FileOutputStream;
import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;
import java.io.PrintWriter;
import java.net.URL;
import java.text.MessageFormat;
import java.util.Properties;
import java.util.ResourceBundle;
import javax.swing.BorderFactory;
import javax.swing.ImageIcon;
import javax.swing.JButton;
import javax.swing.JDialog;
import javax.swing.JFileChooser;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JTextField;
import javax.swing.JToolBar;
import javax.swing.SwingUtilities;
import javax.swing.UIManager;

/**
 *	vt[
 *	@author Ayumi Nakabayashi
 *	@version 0.1 2003/6/24
 */
public abstract class ElecMeasureFrame extends JFrame implements Printable {
	/** t[̃VOgCX^X */
	static ElecMeasureFrame frame;
	/** ۉbZ[W\[X */
	static ResourceBundle r;

	/** vpeB̃t@C */
	static String title;
	/** vpeB */
	static Properties prop = new Properties();

	/** c[o[ƌvp[^pli[pl */
	JPanel controlPanel;
	/** vp[^pl */
	JPanel paramPanel;
	/** OtGA */
	GraphComponent gc;
	/** bZ[WGA */
	JLabel messageArea;

	/** sIuWFNg */
	MeasureExecutor currentExecutor;
	/** t@CI */
	static JFileChooser fileChooser;

	/** vJn{^ */
	ButtonWithFixedToolTip startButton;
	/** v~{^ */
	ButtonWithFixedToolTip stopButton;
	/** f[^ۑ{^ */
	ButtonWithFixedToolTip saveDataButton;
	/** Otۑ{^ */
	ButtonWithFixedToolTip savePlotButton;

	/** t@Cj[ */ 
	JMenu fileMenu;
	/** IvVj[ */ 
	JMenu optionMenu;

	/**
	 *	AvP[ṼCX^X쐬.
	 */
	public ElecMeasureFrame(String title) {
		super(title);
	}

	/**
	 *	s.
	 */
	public void initialize() {
		Container contentPane = getContentPane();

		setJMenuBar(createMenuBar());

		controlPanel = new JPanel(new BorderLayout());
		contentPane.add(controlPanel, BorderLayout.NORTH);

		JToolBar tb = new JToolBar();
		tb.add(startButton = new StartButton());
		tb.add(stopButton = new StopButton());
		tb.addSeparator();
		tb.add(saveDataButton = new SaveDataButton());
		tb.add(savePlotButton = new SavePlotButton());
		tb.putClientProperty("JToolBar.isRollover", Boolean.TRUE);
		controlPanel.add(tb, BorderLayout.NORTH);

		currentExecutor = (MeasureExecutor) paramPanel;
		controlPanel.add(paramPanel, BorderLayout.CENTER);

		gc = new GraphComponent();
		gc.setPreferredSize(new Dimension(640, 400));
		contentPane.add(gc, BorderLayout.CENTER);

		messageArea = new JLabel();
		messageArea.setBorder(BorderFactory.createEtchedBorder());
		contentPane.add(messageArea, BorderLayout.SOUTH);
		showMessage("");

		pack();
		setVisible(true);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		addWindowListener(new WindowAdapter() {
			public void windowClosed(WindowEvent e) {
				quit();
			}
		});
	}

	/**
	 *	ftHg̃j[o[쐬.
	 *	ftHg̃j[̓t@Cj[̂.
	 */
	protected JMenuBar createMenuBar() {
		JMenuBar mb = new JMenuBar();

		// t@Cj[
		fileMenu = new JMenu(gets("menu.File"));
		JMenuItem saveDataItem = new JMenuItem(gets("menuItem.SaveData"));
		saveDataItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (currentExecutor != null)
					currentExecutor.saveData();
			}
		});
		fileMenu.add(saveDataItem);
		JMenuItem savePlotItem = new JMenuItem(gets("menuItem.SaveGraph"));
		savePlotItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (currentExecutor != null)
					currentExecutor.savePlot();
			}
		});
		fileMenu.add(savePlotItem);
		JMenuItem printPropItem = new JMenuItem(gets("menuItem.PrintProp"));
		printPropItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				showPrintPropDialog();
			}
		});
		fileMenu.add(printPropItem);
		JMenuItem printItem = new JMenuItem(gets("menuItem.Print"));
		printItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if (currentExecutor != null) {
					PrinterJob printJob = PrinterJob.getPrinterJob();
					printJob.setPrintable(frame);
					if (printJob.printDialog()) {
						try {
							printJob.print();
						} catch (Exception ex) {
							ex.printStackTrace();
						}
					}
				}
			}
		});
		fileMenu.add(printItem);

		JMenuItem exitItem = new JMenuItem(gets("menuItem.Exit"));
		exitItem.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				quit();
			}
		});
		fileMenu.add(exitItem);
		mb.add(fileMenu);
		return mb;
	}

	/**
	 *	UIIj[ɒǉAj[o[ɓo^.
	 *	@param m ̃j[UIIǉ.
	 *	@param mb m o^郁j[o[.
	 */
	protected static void addUIselector(JMenu m, JMenuBar mb) {
		ActionListener changeUIListener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				String cmd = e.getActionCommand();
				String lf;
				if (cmd.equals(gets("menuItem.Motif")))
					lf = "com.sun.java.swing.plaf.motif.MotifLookAndFeel";
				else if (cmd.equals(gets("menuItem.Windows")))
					lf = "com.sun.java.swing.plaf.windows.WindowsLookAndFeel";
				else
					lf = "javax.swing.plaf.metal.MetalLookAndFeel";
				try {
					UIManager.setLookAndFeel(lf);
				} catch (Exception ex) {}
				SwingUtilities.updateComponentTreeUI(frame);
				fileChooser = null;
				frame.pack();
			}
		};
		JMenuItem metalItem = new JMenuItem(gets("menuItem.Metal"));
		metalItem.addActionListener(changeUIListener);
		m.add(metalItem);
		JMenuItem motifItem = new JMenuItem(gets("menuItem.Motif"));
		motifItem.addActionListener(changeUIListener);
		m.add(motifItem);
		JMenuItem windowsItem = new JMenuItem(gets("menuItem.Windows"));
		windowsItem.addActionListener(changeUIListener);
		m.add(windowsItem);
		mb.add(m);
	}

	/**
	 *	t@C̃C[WŃACR쐬.
	 *	@param fn OtBbNĂt@C.
	 */
	static public ImageIcon createIcon(String fn) {
		URL url = frame.getClass().getResource(fn);
		return new ImageIcon(url);
	}

	/**
	 *	s.
	 *	@param g ̃OtBNXReLXgň.
	 *	@param pf y[WtH[}bg
	 *	@param pi y[Wԍ
	 */
	public int print(Graphics g, PageFormat pf, int pi) throws PrinterException {
		if (pi >= 1)
			return Printable.NO_SUCH_PAGE;
		gc.paint((Graphics2D) g);
		return Printable.PAGE_EXISTS;
	}

	/**
	 *	vJn{^.
	 */
	class StartButton extends ButtonWithFixedToolTip {
		public StartButton() {
			super(createIcon("start.png"), gets("tooltip.Start"));
		}
		public void actionPerformed(ActionEvent e) {
			currentExecutor.startMeasure();
		}
	}

	/**
	 *	v~{^
	 */
	class StopButton extends ButtonWithFixedToolTip {
		public StopButton() {
			super(createIcon("stop.png"), gets("tooltip.Stop"));
		}
		public void actionPerformed(ActionEvent e) {
			currentExecutor.stopMeasure();
		}
	}

	/**
	 *	f[^ۑ{^
	 */
	class SaveDataButton extends ButtonWithFixedToolTip {
		public SaveDataButton() {
			super(createIcon("savedata.png"), gets("tooltip.SaveData"));
		}
		public void actionPerformed(ActionEvent e) {
			currentExecutor.saveData();
		}
	}

	/**
	 *	Otۑ{^
	 */
	class SavePlotButton extends ButtonWithFixedToolTip {
		public SavePlotButton() {
			super(createIcon("saveplot.png"), gets("tooltip.SavePlot"));
		}
		public void actionPerformed(ActionEvent e) {
			currentExecutor.savePlot();
		}
	}

	/**
	 *	p[^pl̃t[ɐݒ肷.
	 *	@param p p[^pl
	 */
	void setParameterPanel(JPanel p) {
		controlPanel.remove(paramPanel);
		paramPanel = p;
		currentExecutor = (MeasureExecutor) paramPanel;
		controlPanel.add(paramPanel, BorderLayout.CENTER);
		frame.pack();
	}

	/**
	 *	bZ[WEBhEɕ\.
	 *	@param msg \郁bZ[W
	 */
	public static void showMessage(String msg) {
		if (msg.equals(""))
			msg = " ";
		frame.messageArea.setText(msg);
	}

	/**
	 *	G[bZ[W_CAO\.
	 *	@param msg \郁bZ[W
	 */
	public static void error(String msg) {
		JOptionPane.showMessageDialog(frame, msg, gets("title.Error"),
				JOptionPane.INFORMATION_MESSAGE);
	}

	/**
	 *	CtH[V_CAO\.
	 *	@param msg \郁bZ[W
	 */
	public static void inform(String msg) {
		JOptionPane.showMessageDialog(frame, msg, "Check",
				JOptionPane.INFORMATION_MESSAGE);
	}

	/**
	 *	mF_CAO\.
	 *	@param msg \郁bZ[W
	 */
	static public int confirm(String msg) {
		return JOptionPane.showConfirmDialog(frame, msg, "Confirm",
			JOptionPane.YES_NO_CANCEL_OPTION,
			JOptionPane.WARNING_MESSAGE);
	}

	/**
	 *	Ot\GAԂ.
	 *	@return Ot\R|[lg
	 */
	public GraphComponent getGraphComponent() {
		return gc;
	}

	/**
	 *	vJn.
	 *	~ȊÕ{^уj[gpsɂ.
	 */
	public void notifyMeasureStart() {
		startButton.setEnabled(false);
		saveDataButton.setEnabled(false);
		savePlotButton.setEnabled(false);
		fileMenu.setEnabled(false);
		optionMenu.setEnabled(false);
	}

	/**
	 *	vI.
	 *	ׂĂ̋@\Lɂ.
	 */
	public void notifyMeasureDone() {
		startButton.setEnabled(true);
		saveDataButton.setEnabled(true);
		savePlotButton.setEnabled(true);
		fileMenu.setEnabled(true);
		optionMenu.setEnabled(true);
		showMessage("");
	}

	/**
	 *	vpeBǂݍ
	 */
	public static void readProperties() {
		try {
			File f = new File(title + ".properties");
			if (f.exists()) {
				InputStream is = new BufferedInputStream(new FileInputStream(f));
				prop.load(is);
				is.close();
			}
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
	}

	/**
	 *	vpeBo
	 */
	public static void writeProperties() throws IOException {
		OutputStream os = new BufferedOutputStream(new FileOutputStream(title + ".properties"));
		prop.store(os, title + " properties");
		os.close();
	}

	// Ot

	/** tHg̃TCY */
	JTextField printFontSizeField;
	/** dB ̃XP[ */
	JTextField printDBScaleField;
	/** ΐ̃XP[ */
	JTextField printLogScaleField;
	/** vpeB̃_CAO */
	JDialog printPropDialog;

	/**
	 *	tHg̃TCY𓾂.
	 *	vpeBɓo^ĂȂꍇ́AftHgƂ8Ԃ.
	 */
	public static String getPrintFontSize() {
		return prop.getProperty("PrintFontSize", "8");
	}

	/**
	 *	dB ̃XP[𓾂.
	 *	vpeBɓo^ĂȂꍇ́AftHgƂ1(mm)Ԃ.
	 */
	public static String getPrintDBScale() {
		return prop.getProperty("PrintDBScale", "1");
	}

	/**
	 *	ΐ̃XP[𓾂.
	 *	vpeBɓo^ĂȂꍇ́AftHgƂ25.4(mm)Ԃ.
	 */
	public static String getPrintLogScale() {
		return prop.getProperty("PrintLogScale", "25.4");
	}

	/**
	 *	vpeB_CAO\.
	 */
	protected void showPrintPropDialog() {
		printPropDialog = new JDialog(frame,		// L
				gets("title.PrintProp"),			// ^Cg
				true);								// [_

		JPanel inputPanel = new JPanel();
		inputPanel.setLayout(new GridBagLayout());
		JLabel printFontSize = new JLabel(gets("label.PrintFontSize")+": ");
		constrain(inputPanel, printFontSize, 0, 0, 1, 1, GridBagConstraints.EAST, 2);
		printFontSizeField = new JTextField(getPrintFontSize(), 2);
		constrain(inputPanel, printFontSizeField, 1, 0, 1, 1, GridBagConstraints.WEST, 2);

		JLabel printDBScaleLabel = new JLabel(gets("label.PrintDBScale")+": ");
		constrain(inputPanel, printDBScaleLabel, 0, 1, 1, 1, GridBagConstraints.EAST, 2);

		printDBScaleField = new JTextField(getPrintDBScale(), 4);
		constrain(inputPanel, printDBScaleField, 1, 1, 1, 1, GridBagConstraints.WEST, 2);

		JLabel printLogScaleLabel = new JLabel(gets("label.PrintLogScale")+": ");
		constrain(inputPanel, printLogScaleLabel, 0, 2, 1, 1, GridBagConstraints.EAST, 2);
		printLogScaleField = new JTextField(getPrintLogScale(), 4);
		constrain(inputPanel, printLogScaleField, 1, 2, 1, 1, GridBagConstraints.WEST, 2);

		JPanel buttonPanel = new JPanel();
		JButton okButton = new JButton(gets("button.OK"));
		okButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				prop.setProperty("PrintDBScale", printDBScaleField.getText().trim());
				prop.setProperty("PrintLogScale", printLogScaleField.getText().trim());
				printPropDialog.dispose();
			}
		});
		buttonPanel.add(okButton);
		JButton cancelButton = new JButton(gets("button.Cancel"));
		cancelButton.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				printPropDialog.dispose();
			}
		});
		buttonPanel.add(cancelButton);

		Container dialogContentPane = printPropDialog.getContentPane();
		dialogContentPane.add(inputPanel, BorderLayout.CENTER);
		dialogContentPane.add(buttonPanel, BorderLayout.SOUTH);
		printPropDialog.pack();
		printPropDialog.show();
	}

	/**
	 *	t@C`[UԂ.
	 */
	public static JFileChooser getFileChooser() {
		if (fileChooser == null) {
			fileChooser = new JFileChooser();
			fileChooser.setCurrentDirectory(new File("."));
		}
		return fileChooser;
	}

	/**
	 *	ۑt@CI.
	 *	@return ۑt@C File IuWFNg.
	 *		ۑȂꍇ null.
	 */
	public static File fileSaveDialog() {
		File file = null;
	LOOP:
		for (;;) {
			JFileChooser fileChooser = getFileChooser();
			int state = fileChooser.showSaveDialog(frame);
			file = fileChooser.getSelectedFile();
			if (file == null || state != JFileChooser.APPROVE_OPTION)
				return null;
			if (!file.exists())
				break;
			int result = confirm(MessageFormat.format(gets("error.FileExists"), new Object[] { file }));
			switch (result) {
			case JOptionPane.CLOSED_OPTION:
			case JOptionPane.CANCEL_OPTION:
				return null;
			case JOptionPane.YES_OPTION:
				break LOOP;
			case JOptionPane.NO_OPTION:
				break;
			}
		}
		return file;
	}

    /** GridBagLayout̐w肷 */
    public static void constrain(Container container, Component component,
            int grid_x, int grid_y, int grid_width, int grid_height,
                    int anchor, int pad) {
        constrain(container, component,
		 	grid_x, grid_y, grid_width, grid_height,
			GridBagConstraints.NONE, anchor,
			0.0, 0.0, pad, pad, pad, pad);
    }

    /** GridBagLayout̐w肷 */
    public static void constrain(Container container, Component component,
            int grid_x, int grid_y, int grid_width, int grid_height,
            int fill, int anchor, double weight_x, double weight_y,
            int top, int left, int bottom, int right) {
        GridBagConstraints c = new GridBagConstraints();
        c.gridx = grid_x; c.gridy = grid_y;
        c.gridwidth = grid_width; c.gridheight = grid_height;
        c.fill = fill; c.anchor = anchor;
        c.weightx = weight_x; c.weighty = weight_y;
        if (top + bottom + left + right > 0)
            c.insets = new Insets(top, left, bottom, right);
        ((GridBagLayout)container.getLayout()).setConstraints(component, c);
        container.add(component);
    }

	/**
	 *	\[Xoh獑ۉbZ[Wo.
	 *	@param key L[
	 */
	public static String gets(String key) {
		return r.getString(key);
	}

	/**
	 *	w肳ꂽԑ҂.
	 *	@param ms ҂[ms]
	 */
	public static void sleep(int ms) {
		try {
			Thread.currentThread().sleep(ms);
		} catch (InterruptedException e) {}
	}

	/**
	 *	AvP[VIƂɌĂяo郁\bh.
	 */
	public abstract void quit();
}
