//	Title: FRA.java
//	Description: g͊pl
//	Version: 1.1
//	Date: 2004-6-19
//	Copyright 2004 by Ayumi Nakabayashi. All rights reserved.

import java.awt.Container;
import java.awt.Graphics2D;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.geom.Ellipse2D;
import java.awt.geom.Line2D;
import java.awt.geom.Rectangle2D;
import java.io.BufferedWriter;
import java.io.File;
import java.io.FileWriter;
import java.io.IOException;
import java.io.PrintWriter;
import java.text.MessageFormat;
import java.util.Properties;
import java.util.Vector;
import javax.swing.BorderFactory;
import javax.swing.JCheckBox;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JPanel;
import javax.swing.JTextField;
import fri.swing.graph.GraphComponent;
import fri.swing.graph.GraphUtil;
import fri.swing.graph.PlotGraph;
import fri.swing.graph.Range;
import fri.swing.graph.XYData;
import fri.util.StringTokenizer2;
import fri.util.Util;

/**
 *	g͊pl
 *	@author Ayumi Nakabayashi
 *	@version 1.1 2004-6-19<br>
 *	1.0 2004-4-16
 */
public class FRAPanel extends JPanel implements MeasureExecutor {
	/** et[ */
	static private FRA f;
	/** pl */
	static private FRAPanel instance = null;

	/** gWtB[h */
	JTextField[] rangeField;
	/** gXebvtB[h */
	JTextField[] stepField;
	/** Ot\` */
	JComboBox plotTypeChooser;
	/** ׃Cs[_XtB[h */
	JTextField impedanceField;

	/** CH1 Ot\ */
	JCheckBox ch1CheckBox;
	/** CH2 Ot\ */
	JCheckBox ch2CheckBox;
	/** CH3 Ot\ */
	JCheckBox ch3CheckBox;
	/** CH1 ɐ */
	JComboBox ch1Chooser;
	/** CH2 ɐ */
	JComboBox ch2Chooser;
	/** CH3 ItZbg */
	JTextField offsetField;

	/** ׃Cs[_X */
	double ZL;
	/** Ot\` */
	int type;
	/** dBV \ */
	static final int DBV = 0;
	/** V \ */
	static final int VOLT = 1;
	/** W \ */
	static final int WATT = 2;
	/** Ot\ */
	boolean[] ch = new boolean[3];
	/** CH1̕ */
	double ch1sign;
	/** CH2̕ */
	double ch2sign;
	/** CH3̃ItZbg */
	double offset;
	/** ɑΉW */
	static final double[] sign = { 0.0, 1.0, -1.0 };

	/** f[^o͎̗ */
	String[] colname;
	/** g */
	double[] freq;
	/** f[^ */
	double[][] vo;
	/** x f[^(log10(freq)) */
	double[] x;
	/** y f[^ */
	double[][] y;
	/** Otpf[^ */
	XYData d;

	/** Ot */
	AudioGraph pg;
	/** vXbh */
	FRAMeasureThread mt;

	/**
	 *	FRAp̃pl쐬.
	 */
	private FRAPanel() {
		super();
		Properties p = FRA.prop;

		setBorder(BorderFactory.createEtchedBorder());

		GridBagLayout g = new GridBagLayout();
		setLayout(g);

		JLabel titleLabel = new JLabel(FRA.gets("label.FreqMeasure"));
		FRA.constrain(this, titleLabel, 0, 0, 8, 1, GridBagConstraints.WEST, 2);

		JLabel rangeLabel = new JLabel(FRA.gets("label.FreqRange")+": ");
		FRA.constrain(this, rangeLabel, 0, 1, 1, 1, GridBagConstraints.EAST, 2);

		rangeField = new JTextField[4];
		rangeField[0] = new JTextField(p.getProperty(
				"FRAPanel.Range0", "10"), 5);
		rangeField[1] = new JTextField(p.getProperty(
				"FRAPanel.Range1", "100"), 5);
		rangeField[2] = new JTextField(p.getProperty(
				"FRAPanel.Range2", "100k"), 5);
		rangeField[3] = new JTextField(p.getProperty(
				"FRAPanel.Range3", "10M"), 5);
		for (int i = 0; i < rangeField.length; i++)
			FRA.constrain(this, rangeField[i], i*2+1, 1, 1, 1, GridBagConstraints.WEST, 2);

		JLabel stepLabel = new JLabel(FRA.gets("label.Step")+": ");
		FRA.constrain(this, stepLabel, 0, 2, 1, 1, GridBagConstraints.EAST, 2);
		stepField = new JTextField[3];
		stepField[0] = new JTextField(p.getProperty(
				"FRAPanel.Step0", "20"), 3);
		stepField[1] = new JTextField(p.getProperty(
				"FRAPanel.Step1", "10"), 3);
		stepField[2] = new JTextField(p.getProperty(
				"FRAPanel.Step2", "20"), 3);
		for (int i = 0; i < stepField.length; i++)
		FRA.constrain(this, stepField[i], i*2+2, 2, 1, 1, GridBagConstraints.WEST, 2);
		JLabel plotTypeLabel = new JLabel(FRA.gets("label.PlotType")+": ");
		FRA.constrain(this, plotTypeLabel, 0, 3, 1, 1, GridBagConstraints.EAST, 2);
		plotTypeChooser = new JComboBox();
		plotTypeChooser.setEditable(false);
		plotTypeChooser.addItem(FRA.gets("label.dBV"));
		plotTypeChooser.addItem("V");
		plotTypeChooser.addItem("W");
		plotTypeChooser.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				repaint();
			}
		});
		FRA.constrain(this, plotTypeChooser, 1, 3, 2, 1, GridBagConstraints.WEST, 2);
		plotTypeChooser.validate();
		plotTypeChooser.setSelectedIndex(Util.atoi(p.getProperty(
				"FRAPanel.PlotType", "0")));

		JLabel impedanceLabel = new JLabel(FRA.gets("label.Impedance")+": ");
		FRA.constrain(this, impedanceLabel, 4, 3, 3, 1, GridBagConstraints.EAST, 2);
		impedanceField = new JTextField(p.getProperty(
				"FRAPanel.Impedance", "8"), 5);
		FRA.constrain(this, impedanceField, 7, 3, 2, 1, GridBagConstraints.WEST, 2);

		ch1CheckBox = new JCheckBox("CH1", p.getProperty(
				"FRAPanel.CH1Plot", "1").equals("1"));
		FRA.constrain(this, ch1CheckBox, 1, 4, 2, 1, GridBagConstraints.WEST, 2);
		ch2CheckBox = new JCheckBox("CH2", p.getProperty(
				"FRAPanel.CH2Plot", "1").equals("1"));
		FRA.constrain(this, ch2CheckBox, 3, 4, 2, 1, GridBagConstraints.WEST, 2);
		ch3CheckBox = new JCheckBox("CH3", p.getProperty(
				"FRAPanel.CH3Plot", "0").equals("1"));
		FRA.constrain(this, ch3CheckBox, 5, 4, 2, 1, GridBagConstraints.WEST, 2);

		FRA.constrain(this, new JLabel("CH 3 ="), 0, 5, 1, 1, GridBagConstraints.EAST, 2);

		ch1Chooser = new JComboBox();
		ch1Chooser.setEditable(false);
		ch1Chooser.addItem("");
		ch1Chooser.addItem("+");
		ch1Chooser.addItem("-");
		FRA.constrain(this, ch1Chooser, 1, 5, 1, 1, GridBagConstraints.EAST, 2);
		ch1Chooser.validate();
		ch1Chooser.setSelectedIndex(Util.atoi(p.getProperty(
				"FRAPanel.CH1Polarity", "0")));
		FRA.constrain(this, new JLabel("CH 1+"), 2, 5, 1, 1, GridBagConstraints.WEST, 2);

		ch2Chooser = new JComboBox();
		ch2Chooser.setEditable(false);
		ch2Chooser.addItem("");
		ch2Chooser.addItem("+");
		ch2Chooser.addItem("-");
		FRA.constrain(this, ch2Chooser, 3, 5, 1, 1, GridBagConstraints.EAST, 2);
		ch2Chooser.validate();
		ch2Chooser.setSelectedIndex(Util.atoi(p.getProperty(
				"FRAPanel.CH2Polarity", "0")));
		FRA.constrain(this, new JLabel("CH 2 +"), 4, 5, 1, 1, GridBagConstraints.WEST, 2);

		offsetField = new JTextField(p.getProperty(
				"FRAPanel.CH3Offset", "0"), 4);
		FRA.constrain(this, offsetField, 5, 5, 1, 1, GridBagConstraints.WEST, 2);
	}

	/**
	 *	̃pl̃CX^XԂ.
	 *	@param parent et[
	 */
	static public FRAPanel getInstance(JFrame parent) {
		if (instance == null) {
			f = (FRA) parent;
			instance = new FRAPanel();
		}
		return instance;
	}

	/**
	 *	vJn.
	 */
	public void startMeasure() {
		Properties p = FRA.prop;
		for (int i = 0; i < rangeField.length; i++)
			p.setProperty("FRAPanel.Range"+i, rangeField[i].getText().trim());
		for (int i = 0; i < stepField.length; i++)
			p.setProperty("FRAPanel.Step"+i, stepField[i].getText().trim());
		p.setProperty("FRAPanel.PlotType", String.valueOf(plotTypeChooser.getSelectedIndex()));
		p.setProperty("FRAPanel.Impedance", impedanceField.getText().trim());
		p.setProperty("FRAPanel.CH1Plot", ch1CheckBox.isSelected() ? "1" : "0");
		p.setProperty("FRAPanel.CH2Plot", ch2CheckBox.isSelected() ? "1" : "0");
		p.setProperty("FRAPanel.CH3Plot", ch3CheckBox.isSelected() ? "1" : "0");
		p.setProperty("FRAPanel.CH1Polarity", String.valueOf(ch1Chooser.getSelectedIndex()));
		p.setProperty("FRAPanel.CH2Polarity", String.valueOf(ch2Chooser.getSelectedIndex()));
		p.setProperty("FRAPanel.CH3Offset", offsetField.getText().trim());

		FRA.aa.setup();
		if (!FRA.aa.isready()) {
			FRA.error("FRA not responding.");
			return;
		}

		// ͒l̊lƃ`FbN
		ZL = AudioUtil.atofFactored(impedanceField.getText());
		if (ZL <= 0.0) {
			f.error(f.gets("error.ZL"));
			return;
		}
		int n = 3;						// n
		colname = new String[n];
		for (int i = 0; i < n; i++)
			colname[i] = "Ch" + (i+1);

		Vector v = new Vector(50);
		for (int i = 0; i < stepField.length; i++) {
			if (parseFreqRange(v, rangeField[i], rangeField[i+1], stepField[i], i==0))
				return;
		}

		updateGraphTypeParam();

		n = v.size();					// g̐
		freq = new double[n];
		x = new double[n];
		for (int i = 0; i < n; i++) {
			freq[i] = ((Double)v.elementAt(i)).doubleValue();
			x[i] = GraphUtil.log10(freq[i]);
		}

		vo = new double[n][colname.length];
		y = new double[n][colname.length];
		for (int i = 0; i < n; i++)
			for (int j = 0; j < colname.length; j++) {
				vo[i][j] = y[i][j] = Double.NaN;
			}
		d = new XYData(x, y);
		createGraph();

		mt = new FRAMeasureThread(this, freq);
		f.notifyMeasureStart();
		new Thread(mt).start();
	}

	/**
	 *	v𒆎~.
	 */
	public void stopMeasure() {
		if (mt != null)
			mt.cancel();
	}

	/**
	 *	f[^ۑ.
	 */
	public void saveData() {
		if (vo == null) {
			f.error(f.gets("error.NoData"));
			return;
		}

		File file = FRA.fileSaveDialog();
		if (file == null)
			return;

		try {
			PrintWriter o = new PrintWriter(
							new BufferedWriter(
							new FileWriter(file)));
			// wb_
			int ncol = colname.length;
			o.print("idx,Frequency");
			for (int i = 0; i < ncol; i++)
				o.print("," + colname[i]);
			o.println();

			int n = vo.length;
			for (int i = 0; i < n; i++) {
				o.print((i+1) + "," + freq[i]);
				for (int j = 0; j < ncol; j++)
					o.print("," + vo[i][j]);
				o.println();
			}
			o.close();
			f.showMessage(MessageFormat.format(f.gets("info.SaveDataComplete"), new Object[] { file }));
		} catch (IOException e) {
			f.error(e.getMessage());
		}
	}

	/**
	 *	Otۑ.
	 */
	public void savePlot() {
		if (vo == null) {
			f.error(f.gets("error.NoData"));
			return;
		}

		File file = FRA.fileSaveDialog();
		if (file == null)
			return;

		double pt = Util.atof(ElecMeasureFrame.getPrintFontSize());
		double logScale = Util.atof(ElecMeasureFrame.getPrintLogScale());
		double dBScale = Util.atof(ElecMeasureFrame.getPrintDBScale());
		double w = (pg.X.getMaxValue() - pg.X.getMinValue()) *
				logScale / 25.4 * 72.0;
		w += 4.6 * pt;
		// System.out.println("w=" + w + "pt");
		double h = (pg.Y.getMaxValue() - pg.Y.getMinValue()) *
				((type == DBV) ? dBScale : logScale) * 72.0 / 25.4;
		// System.out.println("h=" + h + "pt");
		h += 4.6 * pt;
		double x = Math.floor((595.0 - w) / 2.0);
		double y = Math.floor((841.0 - h) / 2.0);
		Rectangle2D r = new Rectangle2D.Double(x, y, w, h);
		System.out.println("r=" + r);

		try {
			f.getGraphComponent().printPS(file.getPath(), pt, r);
			f.showMessage(MessageFormat.format(f.gets("info.SaveDataComplete"), new Object[] { file }));
		} catch (IOException ioe) {
			f.error(ioe.getMessage());
		}
	}

	/**
	 *	p[^߂.
	 *	start Ȃǉ͂Ȃ.
	 *	łȂāAend ̏ꍇA
	 *	includeStart ȂJnl݂̂i[AłȂΉȂ.
	 *	start, end ɗLȐlĂȂA
	 *	start  10^(1/step) |l end 𒴂ȂԁAli[.
	 *	end i[ false Ԃ.
	 *	G[(0܂͕̒l) true Ԃ.
	 *	@param v ʂi[xN^[
	 *	@param start JnlĂeLXgtB[h
	 *	@param end IlĂeLXgtB[h
	 *	@param step lĂeLXgtB[h
	 *	@param includeStart Jnli[ׂ
	 */
	boolean parseFreqRange(Vector v, JTextField start, JTextField end, 
			JTextField step, boolean includeStart) {
		// start ɒlĂ邩ǂ`FbN
		String startStr = start.getText().trim();
		if (startStr.length() == 0)
			return false;

		// Jnl𓾂
		double fStart = AudioUtil.atofFactored(startStr);
		if (fStart <= 0.0) {
			f.error(f.gets("error.Freq"));
			return true;
		}
		if (includeStart)
			add(v, fStart);

		// Il
		String endStr = end.getText().trim();
		if (endStr.length() == 0)
			return false;

		double fEnd = AudioUtil.atofFactored(endStr);
		if (fEnd <= 0.0) {
			f.error(f.gets("error.Freq"));
			return true;
		}
		if (fEnd < fStart) {
			f.error(f.gets("error.FreqNotAscending"));
			return true;
		}

		// 𓾂
		int istep = Util.atoi(step.getText().trim());
		if (istep <= 0) {
			f.error(f.gets("error.Step"));
			return true;
		}
		double r = Math.pow(10.0, 1.0 / istep);	// 1Xebv̔䗦

		double f = fStart * r;
		while (f < fEnd * 0.99999) {
			add(v, f);
			f *= r;
		}
		if (fEnd > ((Double)v.elementAt(v.size()-1)).doubleValue())
			add(v, fEnd);
		return false;
	}

	/**
	 *	xNgɒl܂ĂȂ΂̒lǉ.
	 *	@param v ǉxNg
	 *	@param d ǉl
	 */
	void add(Vector v, double d) {
		d = FRA.aa.frequency(d);
		int n = v.size();
		if (n == 0) {
			v.add(new Double(d));
			return;
		}
		double lastValue = ((Double)v.elementAt(n-1)).doubleValue();
		if (d != lastValue)
			v.add(new Double(d));
	}

	/**
	 *	Ε\̊l̃plɒʒm.
	 *	FRAł͑Ε\͍sȂ̂ŁAȂɂȂ.
	 */
	public void notifyBasis(double[] vinit, int j) {
	}

	/**
	 *	Ot\֘Ap[^ŐV̏Ԃɂ.
	 */
	protected void updateGraphTypeParam() {
		type = plotTypeChooser.getSelectedIndex();
		ch[0] = ch1CheckBox.isSelected();
		ch[1] = ch2CheckBox.isSelected();
		ch[2] = ch3CheckBox.isSelected();
		ch1sign = sign[ch1Chooser.getSelectedIndex()];
		ch2sign = sign[ch2Chooser.getSelectedIndex()];
		offset = Util.atof(offsetField.getText().trim());
	}

	/**
	 *	vlXV.
	 *	@param i XVf[^̍sԍ
	 *	@param j XVf[^̗ԍ
	 *	@param v XVl
	 */
	public synchronized void setNewMeasure(int i, int j, double v) {
		vo[i][j] = v;
	}

	/**
	 *	vlXVꂽƂʒm.
	 *	@param i XVꂽf[^̍sԍ
	 *	@param j XVꂽf[^̗ԍ
	 */
	public synchronized void notifyNewMeasure(int i, int j) {
		vo[i][2] = vo[i][0] * ch1sign + vo[i][1] * ch2sign + offset;
		Graphics2D g2 = (Graphics2D) f.getGraphComponent().getGraphics();
		for (j = 0; j < 3; j++) {
			if (ch[j]) {
				y[i][j] = convert(vo[i][j]);
				pg.newPoint(g2, x[i], y[i][j], j);
				if (i != 0)
					pg.newLine(g2, x[i-1], y[i-1][j], x[i], y[i][j], j);
			}
		}
	}

	/**
	 *	v̏Iʒm.
	 */
	public void notifyMeasureDone() {
		f.notifyMeasureDone();
	}

	/**
	 *	f[^̒lɍ킹ĕϊ.
	 */
	double convert(double vo) {
		if (type == DBV)
			return vo;
		double v = Math.pow(10.0, vo/20.0);
		if (type == VOLT)
			return GraphUtil.log10(v);
		return GraphUtil.log10(v * v / ZL);
	}

	/**
	 *	Otĕ`悷.
	 */
	public void repaint() {
		if (y == null)
			return;
		updateGraphTypeParam();
		for (int i = 0; i < vo.length; i++) {
			vo[i][2] = vo[i][0] * ch1sign + vo[i][1] * ch2sign + offset;
			for (int j = 0; j < colname.length; j++)
				y[i][j] = Double.NaN;
		}
		for (int j = 0; j < 3; j++) {
			if (ch[j]) {
				for (int i = 0; i < x.length; i++) {
					y[i][j] = convert(vo[i][j]);
				}
			}
		}
		createGraph();
	}

	/**
	 *	݂̃p[^ɏ]ăOt쐬.
	 */
	synchronized void createGraph() {
		GraphComponent gc = f.getGraphComponent();
		gc.removeAll();

// fri.math.matrix.Matrix.print(level);
		double maxlev = 20.0;
		double minlev = -60.0;

		Range ylim = GraphUtil.range(y);
		double ymax = ylim.max;
		double ymin = ylim.min;
		if (!Double.isNaN(ymin) && ylim.min == ylim.max) {
			ymax += 0.5;
			ymin -= 0.5;
		}
		String yaxt = "log";
		String ylab = "";
		switch (type) {
		case DBV:
			if (Double.isNaN(ymin)) {
				ymax = maxlev;
				ymin = minlev;
			}
			ymax = Math.ceil(ymax / 10.0) * 10.0;
			ymin = Math.floor(ymin / 10.0) * 10.0;
			yaxt = "dB";
			ylab = "Level (dBV)";
			break;
		
		case WATT:
			if (Double.isNaN(ymin)) {
				double vmax = Math.pow(10.0, maxlev / 20.0);
				double vmin = Math.pow(10.0, minlev / 20.0);
				ymax = GraphUtil.log10(vmax * vmax / ZL);
				ymin = GraphUtil.log10(vmin * vmin / ZL);
			}
			ylab = "Po (W)";
			break;
		
		case VOLT:
			if (Double.isNaN(ymin)) {
				double vmax = Math.pow(10.0, maxlev / 20.0);
				double vmin = Math.pow(10.0, minlev / 20.0);
				ymax = GraphUtil.log10(vmax);
				ymin = GraphUtil.log10(vmin);
			}
			ylab = "Vo (V)";
			break;
		}
// System.out.println("ymax=" + ymax + ", ymin=" + ymin + ", yaxt=" + yaxt + ", ylab=" + ylab);
		pg = new AudioGraph(d,
			"log", x[0], x[x.length-1], "Frequency (Hz)",
			yaxt, ymin, ymax, ylab);
		gc.add(pg);
		gc.repaint();
	}
}
