//	Title: FRAm.java
//	Description: g͊
//	Version: 1.0
//	Date: 2004-4-16
//	Copyright 2004 by Ayumi Nakabayashi. All rights reserved.

import java.awt.BorderLayout;
import java.awt.Container;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.WindowAdapter;
import java.awt.event.WindowEvent;
import java.io.BufferedInputStream;
import java.io.File;
import java.io.FileInputStream;
import java.io.IOException;
import java.io.InputStream;
import java.text.MessageFormat;
import java.util.Properties;
import java.util.ResourceBundle;
import javax.swing.JButton;
import javax.swing.JComboBox;
import javax.swing.JFrame;
import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JPanel;
import javax.swing.JTextField;
import fri.util.Util;

/**
 *	g͊
 *	@author Ayumi Nakabayashi
 *	@version 1.0 2004/4/16
 */
public class FRAm extends JFrame {
	/** FRAhCo */
	static FRADriver aa;
	/** vpeB */
	static Properties prop = new Properties();

	double f = 1e3;

	JPanel freq_panel;
	JPanel button_panel;
	JTextField freq;
	JComboBox unit;

	/**
	 *	AvP[ṼCX^X쐬.
	 */
	public FRAm() {
		super("FRA manual control");
	}

	/**
	 *
	 */
	public void initialize() {
		Container contentPane = getContentPane();
		aa = new FRADriver(prop);
		aa.setup();
		if (!aa.isready()) {
			System.err.println("FRA not responding.");
			System.exit(0);
		}

		freq_panel = new JPanel();
		JLabel titleLabel = new JLabel("Freq");
		freq_panel.add(titleLabel);
		freq = new JTextField("1", 8);
		freq.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				f = Util.atof(freq.getText());
				int n = unit.getSelectedIndex();
				f *= Math.pow(10.0, n * 3);
				f = Math.rint(f);
				set_freq();
			}
		});
		freq_panel.add(freq);
		unit = new JComboBox();
		unit.setEditable(false);
		unit.addItem("Hz");
		unit.addItem("KHz");
		unit.addItem("MHz");
		unit.addActionListener(new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				System.out.println("f=" + f + "Hz");
				aa.setFrequency(f);
			}
		});
		unit.validate();
		unit.setSelectedIndex(1);
		freq_panel.add(unit);
		contentPane.add(freq_panel, BorderLayout.NORTH);

		button_panel = new JPanel();
		ActionListener button_listener = new ActionListener() {
			public void actionPerformed(ActionEvent e) {
				change_freq(e.getActionCommand());
			}
		};
		JButton ddd = new JButton("<<<");
		ddd.addActionListener(button_listener);
		JButton dd = new JButton("<<");
		dd.addActionListener(button_listener);
		JButton d = new JButton("<");
		d.addActionListener(button_listener);
		JButton uuu = new JButton(">>>");
		uuu.addActionListener(button_listener);
		JButton uu = new JButton(">>");
		uu.addActionListener(button_listener);
		JButton u = new JButton(">");
		u.addActionListener(button_listener);
		button_panel.add(ddd);
		button_panel.add(dd);
		button_panel.add(d);
		button_panel.add(u);
		button_panel.add(uu);
		button_panel.add(uuu);
		contentPane.add(button_panel, BorderLayout.SOUTH);

		pack();
		setVisible(true);
		setDefaultCloseOperation(DISPOSE_ON_CLOSE);
		addWindowListener(new WindowAdapter() {
			public void windowClosed(WindowEvent e) {
				if (aa != null)
					aa.close();
				System.exit(0);
			}
		});
	}

	static double log10(double x) {
		return Math.log(x) / Math.log(10.0);
	}

	void change_freq(String s) {
		int n = (int) Math.floor(log10(f+0.5));
		if (s.equals("<<<")) {
			f -= Math.pow(10.0, n);
		} else if (s.equals("<<")) {
			f -= Math.pow(10.0, n-1);
		} else if (s.equals("<")) {
			f -= Math.pow(10.0, n-2);
		} else if (s.equals(">>>")) {
			f += Math.pow(10.0, n);
		} else if (s.equals(">>")) {
			f += Math.pow(10.0, n-1);
		} else if (s.equals(">")) {
			f += Math.pow(10.0, n-2);
		}
		f = Math.rint(f);
		set_freq();
	}

	void set_freq() {
		if (f < 1)
			f = 1.0;
		if (f > 16e6)
			f = 16e6;
		int n = (int) Math.floor(log10(f+0.5));
		String fstr = null;
		if (n >= 6) {
			unit.setSelectedIndex(2);
			fstr = String.valueOf(f/1e6);
		} else if (n >= 3) {
			unit.setSelectedIndex(1);
			fstr = String.valueOf(f/1e3);
		} else {
			unit.setSelectedIndex(0);
			fstr = String.valueOf(f);
		}
		freq.setText(fstr);
	}

	/**
	 *	AvP[VN.
	 */
	public static void main(String[] args) {
		try {
			File f = new File("FRA.properties");
			if (f.exists()) {
				InputStream is = new BufferedInputStream(new FileInputStream(f));
				prop.load(is);
				is.close();
			}
		} catch (IOException e) {
			System.out.println(e.getMessage());
		}
		FRAm frame = new FRAm();
		frame.initialize();
	}
}
