//	Title: LogAxis.java
//	Description: ΐ
//	Version: 1.0
//	Date: 2004-4-16
//	Copyright 2004 by Ayumi Nakabayashi. All rights reserved.

import fri.swing.graph.GraphUtil;
import fri.swing.graph.Range;

/**
 *	ΐ
 *	@author Ayumi Nakabayashi
 *	@version 1.0 2004-4-16
 */
public class LogAxis {
	/** (pΐƂ)ŏl */
	double min;
	/** (pΐƂ)ől */
	double max;
	/** ⏕̈ʒu */
	double[] tick;
	/** ڐ̈ʒu */
	double[] at;
	/** ڐ̕ */
	String[] lab;

	static private String[] exts = {
		"p", "n", "u", "m", "", "k", "M", "G"
	};
	static private String[] fwds1 = {
		"", "0.0", "0."
	};
	static private String[] fwds2 = {
		"", "0", "00"
	};

	/**
	 *	ΐڐ߂.
	 *	@param lx pΐf[^.
	 *		̃f[^ׂēŏlAől߂.
	 */
	public LogAxis(double[] lx) {
		Range r = GraphUtil.range(lx);
		init(r.min, r.max, false);
	}

	/**
	 *	ΐڐ߂.
	 *	@param minlx pΐf[^̍ŏl.
	 *	@param maxlx pΐf[^̍ől.
	 */
	public LogAxis(double minlx, double maxlx) {
		init(minlx, maxlx, false);
	}

	/**
	 *	ΐڐ߂.
	 *	@param minlx pΐf[^̍ŏl.
	 *	@param maxlx pΐf[^̍ől.
	 *	@param distmode cOt̏ꍇ true.
	 */
	public LogAxis(double minlx, double maxlx, boolean distmode) {
		init(minlx, maxlx, distmode);
	}

	/**
	 *	ΐ̏s.
	 *	@param minlx pΐf[^̍ŏl.
	 *	@param maxlx pΐf[^̍ől.
	 *	@param distmode cOt̏ꍇ true.
	 */
	void init(double minlx, double maxlx, boolean distmode) {
		double xmini = Math.floor(minlx);
		double xminf = minlx - xmini;
		int ladj;
		if (xminf <= AudioUtil.LOG2 - 1.0e-3) {
			xminf = 0.0;
			ladj = 0;
		} else if (xminf <= AudioUtil.LOG5 - 1.0e-3) {
			xminf = AudioUtil.LOG2;
			ladj = -1;
		} else if (xminf <= 1.0 - 1.0e-3) {
			xminf = AudioUtil.LOG5;
			ladj = -4;
		} else {
			xminf = 1.0;
			ladj = -9;
		}
		min = xmini + xminf;

		double xmaxi = Math.floor(maxlx);
		double xmaxf = maxlx - xmaxi;
		int radj;
		if (xmaxf >= AudioUtil.LOG5 + 1.0e-3) {
			xmaxf = 1.0;
			radj = 9;
		} else if (xmaxf >= AudioUtil.LOG2 + 1.0e-3) {
			xmaxf = AudioUtil.LOG5;
			radj = 4;
		} else if (xmaxf > 1.0e-3) {
			xmaxf = AudioUtil.LOG2;
			radj = 1;
		} else {
			xmaxf = 0.0;
			radj = 0;
		}
		max = xmaxi + xmaxf;

		int ndec = (int)Math.round(xmaxi - xmini);
		if (false) {
			System.out.println("xmini=" + xmini);
			System.out.println("ladj=" + ladj);
			System.out.println("xmaxi=" + xmaxi);
			System.out.println("radj=" + radj);
			System.out.println("ndec=" + ndec);
		}
		tick = new double[ndec*9 + 1 + ladj + radj];
		boolean[] labok = new boolean[tick.length];
		int j = 0;
	LOOP:
		for (int i = 0; ; i++) {
			for (int sub = 1; sub < 10; sub++) {
				double x = xmini + i + GraphUtil.log10(sub);
				if (x > max + 1e-3)
					break LOOP;
				if (x >= min - 1e-3) {
					tick[j] = x;
					labok[j++] = Math.abs(Math.floor(x) - x) < 1e-3;
				}
			}
		}
		labok[0] = true;
		labok[labok.length - 1] = true;
		int nlab = 0;
		for (int i = 0; i < labok.length; i++)
			if (labok[i])
				nlab++;
		at = new double[nlab];
		lab = new String[nlab];
		j = 0;
		for (int i = 0; i < labok.length; i++)
			if (labok[i]) {
				double x = tick[i];
				at[j] = x;
				int idx = (x >= 0.0) ?
					(int)(Math.floor(x) + 0.5) / 3 :
					-(int)(Math.ceil(-x) + 0.5) / 3;
				String ext = exts[idx + 4];
				int rem = (int)(Math.floor(x - (int)(Math.floor(x/3.0) + 0.5) * 3) + 0.5) % 3;
				int m = (int) (Math.pow(10.0, x - Math.floor(x)) + 0.5);
// System.out.println("x=" + x + ", idx=" + idx + ", ext=" + ext + ", rem=" + rem + ", m=" + m);
				if (x < 0.0) {
					if (distmode)
						lab[j] = "0." + "000000000000".substring(0, (int)(-Math.floor(x) + 0.5)-1) + m;
					else
						lab[j] = fwds1[rem+2] + m + ext;
				} else {
					lab[j] = m + fwds2[rem] + ext;
				}
				j++;
			}
	}
}
